# -*- coding: utf-8 -*-

from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
from builtins import super


from .tuple import tupleDesc

class kleeneTuple(tupleDesc):
    """
    the tuple that contains all left over objects in a tuple/tuple expression

    | e.g. in a lhs description tuple: (a, b, c, d, H\*)
    | H\* is the kleeneTuple, it contains all objects that are left over in the matched shape tuple. 
    | It can be used in a tuple expression in the rhs: [a b H]

    """
    type = 'description-kleeneTuple'    
    def __init__(self, bracket, separator, *args, **kwargs):
        super(kleeneTuple, self).__init__(bracket, separator)
        self.type = 'description-kleeneTuple'