# -*- coding: utf-8 -*-

from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import object
from .symbols import symbols

class tree(object):
    """
    The abstract class for description component
    """
    def compareValue(self, other):
        raise NotImplementedError
        
    def __str__(self):
        raise NotImplementedError
        
    def __repr__(self):
        return str(self)
        
    def __eq__(self, other):
        return self.compareValue(other) == 0
        
    def __ne__(self, other):
        return not self.__eq__(other)

    def duplicate(self):
        return self
        
    def getNumber(self, assignment, sort):
        print(self, self.__class__)
        raise NotImplementedError
        
    def __iter__(self):
        return iter([self])
        
    def map(self, assignment, sort, onto):
        """
        mapping one tree (in one shape description) onto another (lhs description) for
        """
        return self == onto
        
    def checkPartOf(self, other):
        """
        check if one tree is part of another
        """
        if self.type == other.type == 'description-numberLiteral':
            if self.value == other.value:
                return True
            return False
        if self.type == other.type == 'description-stringLiteral':
            if self.s == other.s:
                return True
            return False
        return True
        
    def evaluate(self, assignment, sort):
        """
        Evaluating the description component. Abstract function to be implemented by each component class
        """
        raise NotImplementedError
        
    def apply(self, function, value = None):
        if value is None:
            raise TypeError("function '" + function + "(" + self.__class__ + ")' not recognized")
        raise TypeError("function '" + function + "(" + self.__class__ + ", " 
                        + value.__class__ + ")' not recognized")
                        
    def getEntity(self, index):
        try:
            return self.tuple[index]
        except AttributeError:
            return None
                                
    def contains(self, other):
        """
        default function for checking if this tree contains another
        """
        return self == other
                    
    def functionExists(self, name, assist = None):
        return False
        
    def similarFragment(self, other):
        if self.type != other.type:
            return False
        return self == other
        
    def mergeFragment(self, other):
        return

    @staticmethod
    def parse(desc, reader):
        raise NotImplementedError
        
    @staticmethod
    def parseContinue(desc, reader):
        raise NotImplementedError
        
class DescriptionEvaluatingError(Exception):
    def __init__(self, message = ''):
        super(DescriptionEvaluatingError, self).__init__(message)
