# -*- coding: utf-8 -*-

from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
from builtins import range
from builtins import super
from builtins import str

from .individual import individual

class special(individual):
    """
    Special individual abstract class: Specify individual types that require extra parameters
    to be declared when its sort is created

    e.g.

    * enumerative: the name of all the enumeratives as well as their ordering matrix (for object comparison) are to be declared 
    * color: the color mode, model and behavior is to be declared
    """

    def __init__(self, sort, *args, **kwargs):
        super(special, self).__init__(sort)
        self.description = None
    
    def contains(self, other):
        """
        Check if this special individual contains another
        """
        raise NotImplementedError
        
    def containsInd(self, other):
        return self.contains(other)
        
    def combine(self, other):
        """
        Find the combination of this special individual with another
        """
        raise NotImplementedError
        
    def common(self, other):
        """
        Find the common of this special individual with another
        """
        raise NotImplementedError
        
    def complement(self, other):
        """
        Find the complement of this special individual with another
        """
        raise NotImplementedError
        
    def symcomplement(self, other):
        raise NotImplementedError
