# -*- coding: utf-8 -*-

from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import super
from builtins import str

from .individual import individual
from copy import deepcopy


class url(individual):
    """
    URL class

    **Class Properties:**

    * **Behavior**: :class:`~sortal.form.discrete.discrete`
    * **Sort Argument**: :class:`~sortal.sort.parameter.argument.argument.argumentType`.NONE
    * **Mapping**: :class:`~sortal.map.exactMap.exactMap`
    """
    
    type = 'ind-url'
    
    def __init__(self, sort, value = None, *args, **kwargs):
        """
        creating a url
        """
        super(url, self).__init__(sort)
        if value == None:
            self.value = ''
        else:
            self.value = value
            
    def printVal(self):
        """
        print out a string representing the value of this individual, used in form.printE()
        """
        return str(self.value)   
                
    def isNil(self):
        """
        check if the individual is Nil
        """
        return self.value == ''
        
    def equals(self, other):
        """
        check equality
        """
        return (self.value == other.value)
        
    def compareValue(self, other):
        """
        compare two individuals
        """
        if self.value > other.value:
            return 1
        elif self.value == other.value:
            return 0
        return -1    
        
    def replicateInd(self):
        """
        Create a duplicate of the individual without attributes
        """
        return url(self.sort, self.value)
