# -*- coding: utf-8 -*-

from __future__ import print_function
from __future__ import unicode_literals
from __future__ import division
from __future__ import absolute_import

from builtins import object
class treeLink(object):
    """
    A tree structure for :class:`sortal.grammar.fragment.fragment` for rule analysis and detection
    """
    def __init__(self, content, parent = None, children = None):
        self.content = content
        self.parent = parent
        if children is None:
            self.children = []
        else:
            self.children = children
                
    def __repr__(self):
        return str(self)
        
    def __str__(self):
        s = '~' + str(self.content) + '|'
        for i in self.children:
            s += str(i.content) + '->'
        s = s[:-1]
        return s
        
    def firstChild(self):
        """
        first fragment in the tree
        """
        if len(self.children) == 0:
            return None
        else:
            return self.children[0]
            
    def addChild(self, child):
        """
        add a fragment to the tree
        """
        self.children.append(child)
        
    def sortChildren(self):
        """
        sort fragment tree
        """
        self.children.sort()
        
    def compareValue(self):
        return